CREATE OR REPLACE PROCEDURE                                                                               GENERATE_CN1_REPORT IS

		CURSOR C1 IS SELECT RTRIM(OUCUNO) OUCUNO, RTRIM(OUITNO)OUITNO FROM PFODS.TMP_CN_REPORT;
		
		CURSOR C2 IS SELECT DISTINCT(RTRIM(OUCUNO)) CUSTNO FROM PFODS.TMP_CN_REPORT;
		
		CUNO05		NVARCHAR2(40);
		ITNO05		NVARCHAR2(40);
		QTY05			NUMBER(15,6);
		AMT05			NUMBER(15,2); 
		CO05			NUMBER(8);
		
		CUNO06		NVARCHAR2(40);
		ITNO06		NVARCHAR2(40);
		QTY06			NUMBER(15,6);
		AMT06			NUMBER(15,2); 
		CO06			NUMBER(8);
		
		CUNO06I		NVARCHAR2(40);
		ITNO06I		NVARCHAR2(40);
		QTY06I		NUMBER(15,6);
		AMT06I		NUMBER(15,2); 
		CO06I			NUMBER(8);	
		
		C_CUNO				NVARCHAR2(40);
		C_CUNM				NVARCHAR2(144);
		C_CUA1				NVARCHAR2(144);
		C_STAT				NVARCHAR2(8);
		C_YREF				NVARCHAR2(144);
		C_OREF				NVARCHAR2(144);
		C_ADDRESS			NVARCHAR2(300);
		C_CITY				NVARCHAR2(144);
		C_SDST				NVARCHAR2(6);
		C_PROVINCE		NVARCHAR2(160);
		C_CFC9				NVARCHAR2(10);
		C_SALESENG		NVARCHAR2(160);
		C_SALESNAME		NVARCHAR2(160);
		C_INV					NUMBER(15,2);
		C_PAYM				NVARCHAR2(12);
		C_PAYNM				NVARCHAR2(160);
		C_CREDIT			NUMBER(15,2);
		C_DELI				NVARCHAR2(12);
		C_DELINM			NVARCHAR2(160);
		C_SAA					NVARCHAR2(20);
		
		
		R1	C1%ROWTYPE;
		R2	C2%ROWTYPE;
		
		P_RESULT 			VARCHAR2(250);
		V_SQNO				NUMBER(10);
		V_DAY					VARCHAR2(200);
		V_REMARKS			VARCHAR2(250);
		V_STARTDATE		DATE;

BEGIN

	 P_RESULT := 'SUCCESS';

   -- RETRIEVE DAY OF RUNNING
	 SELECT TO_CHAR(SYSDATE,'DAY') INTO V_DAY FROM DUAL;		
   V_STARTDATE := SYSDATE; 
	
	 DBMS_OUTPUT.PUT_LINE(' ----- START OF RETRIEVE DATA ----- ');

	 BEGIN
	 		DELETE FROM PFODS.OSASTD2006_122;
	 EXCEPTION WHEN OTHERS THEN P_RESULT := 'ERROR IN DELETE OSASTD2006_122 - '||SQLERRM;		
	 COMMIT;
	 END;


   IF P_RESULT = 'SUCCESS' THEN
   		BEGIN	 
	 				INSERT INTO PFODS.OSASTD2006_122
	 				SELECT OUORNO, OUCUNO, OUITNO, OUITCL, OUSMCD, OUORQT, OUSAAM, OUOSDT
	 				FROM   OSASTD_122
	 				WHERE  TO_CHAR(OUOSDT,'YYYY') = '2006';
	 		EXCEPTION WHEN OTHERS THEN P_RESULT := 'ERROR IN INSERT OSASTD2006_122 - '||SQLERRM;
	 		END;
	 		COMMIT;
	 END IF;

   
   IF P_RESULT = 'SUCCESS' THEN
			BEGIN
	 				DELETE FROM PFODS.TMP_CN_REPORT;
	 		EXCEPTION WHEN OTHERS THEN P_RESULT := 'ERROR IN DELETE TMP_CN_REPORT -'||SQLERRM;
	 		END;
	 		COMMIT;
	 END IF;
	
	 
	 IF P_RESULT = 'SUCCESS' THEN
	 		-- RETRIEVE DISTINCT CUSTOMER NUMBER BASED ON MODEL DESCRIPTION  
			BEGIN
				INSERT INTO PFODS.TMP_CN_REPORT(
								OUCUNO, OUCONO, OUITNO, OUITDS,
								QTY05, AMT05, NOOFCO05, QTY06, AMT06, INQTY06, INAMT06, NOOFCO06, OUITCL)
				SELECT DISTINCT(B.OUCUNO) OUCUNO, 1, B.OUITNO OUITNO, RTRIM(A.MDITDS) MDITDS, 
		   				 C.QTY05, C.AMT05, C.CNT05, D.QTY06, D.AMT06, E.QTY06I, E.AMT06I, E.CNT06, F.MMITCL
    		FROM   PFODS.MITLAD A, PFODS.OSASTD_122 B, 
				       (SELECT UCCUNO, UCITNO, 
					             NVL(SUM(UCIVQT),0) QTY05, NVL(SUM(UCSAAM),0) AMT05, COUNT(DISTINCT(UCORNO)) CNT05
								FROM   PFODS.OSBSTD2005_122		
								GROUP  BY UCCUNO, UCITNO) C,
							(	SELECT UCCUNO, UCITNO, NVL(SUM(UCIVQT),0) QTY06, NVL(SUM(UCSAAM),0) AMT06
								FROM   PFODS.OSBSTD_122		
								WHERE TO_CHAR(UCIVDT,'YYYY') = '2006' 						
								GROUP  BY UCCUNO, UCITNO ) D,
				       (SELECT OUCUNO, OUITNO, 
					             NVL(SUM(OUORQT),0) QTY06I, NVL(SUM(OUSAAM),0) AMT06I, COUNT(DISTINCT(OUORNO)) CNT06
								FROM   PFODS.OSASTD2006_122		
								GROUP  BY OUCUNO, OUITNO) E, PFODS.MITMAS F										
				WHERE  RTRIM(B.OUCUNO) = RTRIM(C.UCCUNO(+))
				AND    RTRIM(B.OUITNO) = RTRIM(C.UCITNO(+))
				AND    RTRIM(B.OUCUNO) = RTRIM(D.UCCUNO(+))
				AND    RTRIM(B.OUITNO) = RTRIM(D.UCITNO(+))
				AND    RTRIM(B.OUCUNO) = RTRIM(E.OUCUNO(+))
				AND    RTRIM(B.OUITNO) = RTRIM(E.OUITNO(+))		
				AND    B.OUCONO = A.MDCONO(+)
				AND    RTRIM(B.OUITNO) = RTRIM(A.MDITNO(+))	
				AND    A.MDCONO = F.MMCONO
				AND    RTRIM(A.MDITNO) = RTRIM(F.MMITNO)  															
				AND    TO_CHAR(B.OUOSDT,'YYYY') IN ('2005','2006');
			EXCEPTION WHEN OTHERS THEN P_RESULT := 'ERROR IN INSERT TMP_CN_REPORT - '||SQLERRM; DBMS_OUTPUT.PUT_LINE('ERROR 1:'||SQLERRM);
			END;			
		  COMMIT; 
		END IF;

		

		IF P_RESULT = 'SUCCESS' THEN
    		-- UPDATE THE CUSTOMER DETAILS
				OPEN C2;
				LOOP
						FETCH C2 INTO R2;
						EXIT WHEN C2%NOTFOUND;

								-- RETRIEVE CUSTOMER DETAILS
								BEGIN
										SELECT NVL(A.OKCUNO,'X'), RTRIM(A.OKCUNM), RTRIM(A.OKCUA1), A.OKSTAT, RTRIM(A.OKYREF), RTRIM(A.OKOREF), 
													 RTRIM(A.OKCUA2)||' '||RTRIM(A.OKCUA3), A.OKCUA4,
											 		 A.OKSDST, RTRIM(B.CTTX15), A.OKCFC9, A.OKSMCD, RTRIM(C.CTTX40), A.OKTDIN, 
											 		 A.OKTEPY, RTRIM(D.CTTX15), A.OKCRL3, 
											 		 A.OKTEDL, RTRIM(E.CTTX15), A.OKCFC1
							  		INTO   C_CUNO, C_CUNM, C_CUA1, C_STAT, C_YREF, C_OREF, C_ADDRESS, C_CITY,
							  					 C_SDST, C_PROVINCE, C_CFC9, C_SALESENG, C_SALESNAME, C_INV, C_PAYM, C_PAYNM, C_CREDIT,
							  			 		 C_DELI, C_DELINM, C_SAA
										FROM   PFODS.OCUSMA_122 A, PFODS.CSYTAB B, PFODS.CSYTAB C, PFODS.CSYTAB D, PFODS.CSYTAB E
										WHERE  A.OKCONO = 1
										AND    RTRIM(A.OKCUNO) = R2.CUSTNO
										AND    A.OKCONO = B.CTCONO
										AND    A.OKSDST = B.CTSTKY
										AND    B.CTSTCO = 'SDST'
										AND    B.CTCONO = C.CTCONO
										AND    C.CTSTCO = 'SMCD'
										AND    A.OKSMCD = C.CTSTKY
										AND    C.CTCONO = D.CTCONO
										AND    D.CTSTCO = 'TEPY'
										AND    A.OKTEPY = D.CTSTKY
										AND    A.OKLHCD = D.CTLNCD
										AND    D.CTCONO = E.CTCONO
										AND    E.CTSTCO = 'TEDL'
										AND    A.OKTEDL = E.CTSTKY
										AND    A.OKLHCD = E.CTLNCD;				
								EXCEPTION WHEN NO_DATA_FOUND THEN C_CUNO := 'X';
							  		      WHEN OTHERS THEN C_CUNO := 'X'; DBMS_OUTPUT.PUT_LINE('ERROR 2: '||SQLERRM);
								END;		

								IF C_CUNO != 'X' THEN
										-- UPDATE DETAILS TO TMP_CN_REPORT
										BEGIN
												UPDATE TMP_CN_REPORT 
												SET    OKCUNM = C_CUNM,
											 				 OKCUA1 = C_CUA1,
											 				 OKSTAT = C_STAT,
											 				 OKYREF = C_YREF,
											 				 OKCUA2 = C_ADDRESS,											 
											 				 OKCUA4 = C_CITY,
											 				 OKSDST = C_PROVINCE,
											 				 OKCFC9 = C_CFC9,
											 				 OKSMCD = C_SALESNAME,
											 				 OKTDIN = C_INV,
											 				 OKTEPY = C_PAYNM,
											 				 OKCRL3 = C_CREDIT,
											 				 OKTEDL = C_DELINM,
											 				 OKCFC1 = C_SAA
												WHERE  RTRIM(OUCUNO) = R2.CUSTNO;
									 EXCEPTION WHEN OTHERS THEN DBMS_OUTPUT.PUT_LINE('ERROR ON UPDATE CUST: '||SQLERRM);
									 END;
									 COMMIT;
								END IF;
				END LOOP;
				CLOSE C2;
			END IF;


  		IF P_RESULT = 'SUCCESS' THEN
   	 		 V_REMARKS := 'GENERATE_CN1_REPORT: SUCCESSFUL';
  		ELSE
   	 		 V_REMARKS := P_RESULT;
  		END IF;

  		DBMS_OUTPUT.PUT_LINE('RESULT: '||V_REMARKS);

			-- RETRIEVE SEQUENCE NUMBER		
  		SELECT SQREPLICATION.NEXTVAL INTO V_SQNO FROM DUAL;
    
  		-- LOG INTO RPTREPLICAT FOR START OF PROCEDURE RUNNING
  		BEGIN
     			INSERT INTO RPTREPLICAT (SQNO, STARTDATE, ENDDATE, COMMENTA, COMMENTB)
     			VALUES (V_SQNO, V_STARTDATE, SYSDATE, V_REMARKS, V_DAY);
  		EXCEPTION WHEN OTHERS THEN DBMS_OUTPUT.PUT_LINE('ERROR INSERT INTO RPTREPLICAT');       
  		END;		
  		COMMIT;


			DBMS_OUTPUT.PUT_LINE(' ----- END OF RETRIEVE DATA ----- ');
  
END;
/

